<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  computed: {},
  mounted() {
    const observer = new IntersectionObserver(this.parallaxSection, {
      rootMargin: '0px',
      threshold: 0,
    });
    const children = Array.from(
      document.querySelectorAll('.benefit-hero-container'),
    );
    children.forEach((child) => observer.observe(child));
  },
  methods: {
    parallaxSection(entries: any) {
      entries.forEach((entry: any) => {
        const element = entry.target;
        const { textContainer } = this.$refs;

        const image = element.querySelector('img');

        if (entry.intersectionRatio > 0) {
          document.addEventListener('scroll', () => {
            const textDistanceFromTop =
              textContainer.getBoundingClientRect().top;
            const imgDistanceToTop = image.getBoundingClientRect().top;
            textContainer.style.transform = `translateY(${
              5 + textDistanceFromTop / 100
            }%)`;
            image.style.transform = `translateY(${
              5 - imgDistanceToTop / 100
            }%)`;
          });
        }
      });
    },
  },
});
</script>

<template>
  <div
    ref="benefitHeroContainer"
    class="benefit-hero-container"
    :class="data.variant"
  >
    <nuxt-img :src="data.image.url" :alt="data.image.alt" />
    <div ref="textContainer" class="text-container">
      <SlpTypography class="value" variant="display1" tag="p">
        {{ data.percent }}<span class="percent">%</span>
      </SlpTypography>
      <SlpTypography variant="body1-bold" tag="p" class="description">{{
        data.description
      }}</SlpTypography>
      <SlpTypography
        v-if="data.footnote"
        variant="body3"
        tag="p"
        class="footnote"
        >{{ data.footnote }}</SlpTypography
      >
    </div>
  </div>
</template>

<style lang="scss" scoped>
.benefit-hero-container {
  display: flex;

  img {
    max-width: 750px;
  }
  .text-container {
    display: flex;
    flex-direction: column;
    justify-content: center;
    position: relative;
    left: -$spacing-96;
    .value,
    .percent {
      font-size: 160px;
      line-height: 160px;
      letter-spacing: -9px;
      font-weight: 800;
    }
    .description {
      max-width: 360px;
      line-height: 24px;
    }
  }
  &.light {
    color: #f6f3fe;
  }
  .percent {
    color: #a989f5;
  }
  .footnote {
    margin-top: $spacing-8;
  }

  @media (max-width: $breakpoint-lg) {
    flex-direction: column;
    .text-container {
      left: 0;
      margin: -5rem 0;
    }
    .description,
    .footnote {
      padding-left: 25%;
    }
  }
}
</style>
